<script lang="ts" setup>
import { computed } from 'vue';

// props
const props = defineProps<{
  type: 'link' | 'display' | 'removable';
  link?: string;
}>();

// computed values
const additionalClass = computed(() =>
  props.type === 'removable'
    ? 'ecl-tag--removable'
    : props.type === 'display'
    ? 'ecl-tag--display'
    : ''
);
const isLink = computed(() => props.type === 'link');
const isDisplay = computed(() => props.type === 'display');
const isRemovable = computed(() => props.type === 'removable');

const computedClasses = computed(() => ['ecl-tag', additionalClass.value]);
</script>

<template>
  <a v-if="isLink" :href="link || '#'" :class="computedClasses"><slot /></a>

  <div v-else-if="isDisplay" :class="computedClasses"><slot /></div>

  <button
    v-else-if="isRemovable"
    type="button"
    aria-label="Dismiss"
    class="ecl-tag ecl-tag--removable"
  >
    <slot />
    <span class="ecl-tag__icon text-white">
      <span class="ecl-icon ecl-icon--xs ecl-tag__icon-close">
        <icon-ec-close />
      </span>
      <span class="ecl-icon ecl-icon--xs ecl-tag__icon-close-filled">
        <icon-ec-close-filled />
      </span>
    </span>
  </button>

  <div v-else>Invalid tag type</div>
</template>
